/***************************************************************************
                          fleetview.h  -  description
                             -------------------
    begin                : Sun Mar 10 2002
    copyright            : (C) 2002 by Michael Andreen
    email                : whale@linux.nu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLEETVIEW_H
#define FLEETVIEW_H

#include <map>
#include <vector>

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qsignalmapper.h>

#include "fleet.h"

class RoidsEditView;
class ResourceView;

/**
  *@author Michael Andreen
  */
class FleetView : public QWidget
{
   Q_OBJECT
public: 
	FleetView(const Fleet* fleet, bool friendly, QWidget *parent=0, const char *name=0);
	~FleetView();

	void viewFleet(const Fleet* fleet, bool friendly);

	const Fleet* fleet();
	bool isHome();
	bool isFriendly();

	bool isModified();

public slots:
	void slotViewTickRange(int min = -1 , int max = -1);
	void slotSetResultMode(int i);
	
signals:
	void fleetChanged(const Fleet*);

protected slots:
	void unitsChanged(const QString& number);
	void slotRoidsChanged(const QString& type, int value);

protected:
	void findNames();
	void buildUnitTable();
	void fillTable();
	
	QVBoxLayout* m_MainLayout;
	QGridLayout* m_UnitsLayout;
	QLabel*      m_UnitName; 

	RoidsEditView* m_RoidsEditView;
	ResourceView*  m_ResourceView;

	Fleet* m_Fleet;
	bool  m_bHome;
	bool  m_bFriendly;

	bool m_Modified;

	int m_iMinTick;
	int m_iMaxTick;
	int m_iResultMode;

	std::vector<QString>      m_Names;
	std::map<QString, QLabel*>    m_UnitsLabel;
	std::map<QString, QLineEdit*> m_UnitsEdit;
	std::map<QString, QLineEdit*> m_UnitsLostSurvivedView;
};

#endif
